// ---------------------------------------------------------------------------
// jump_and_jet.cs -- Version 1.8 -- October 28, 2000
// by Lorne Laliberte (writer@planetstarsiege.com)
//
// Automatically jump whenever you jet
//
// http://www.writerscripts.com
// ---------------------------------------------------------------------------

include("writer\\version.cs");
version("writer\\jump_and_jet.cs", "1.8", "Lorne Laliberte", "Oct 28, 2000");

include("writer\\event.cs");
include("writer\\jet.cs");
include("writer\\save.cs");
include("writer\\you_respawned.cs");

// ---------------------------------------------------------------------------
// DEFAULT SETTINGS:
//
// Edit these if you're running this script for the first time
// All subsequent settings must be done in the config\wp_jump_and_jet.cs file

    // Always jump whenever you jet
    $JumpAndJet::AlwaysOn = "true";

    // Hold a key down to jump and jet -- this way doesn't prevent you
    // from jetting without jumping
    //bind(keyboard0, make, alt, "whatever", TO, "JumpAndJet(1);");
    //bind(keyboard0, break, alt, "whatever", TO, "JumpAndJet(0);");

// ---------------------------------------------------------------------------

WriterPrefs::load("jump_and_jet");

function JumpAndJet(%on)
{
    if( !$PilotMode && (getMountedItem(0) != -1) )
    {
        if(%on)
        {
    		postAction(2048, IDACTION_MOVEUP, 1);
    		postAction(2048, IDACTION_JET, 1);
        }
        else
        {
    		postAction(2048, IDACTION_MOVEUP, 0);
    		postAction(2048, IDACTION_JET, 0);
        }
    }
}


function JumpAndJet::onYouRespawned()
{
	postAction(2048, IDACTION_MOVEUP, 0);
	postAction(2048, IDACTION_JET, 0);
}


// Jumps whenever you jet.  Note that this makes it impossible to jet without
// jumping.  I prefer to do my jump-and-jetting manually.
//
function JumpAndJet::onJetsStarted()
{
    if( !$PilotMode && (getMountedItem(0) != -1) )
    {
        if(Event::Returned(Event::Trigger(eventJump), mute))
            return;

		postAction(2048, IDACTION_MOVEUP, 1);
        tap(pilot_mode_jump, 2);
    }
}

function jump_and_jet::save()
{
    AddExportText("    // Always jump whenever you jet");
    ExportSetting("    $JumpAndJet::AlwaysOn", true);
    AddExportText("");
    AddExportText("    // Hold a key down to jump and jet -- this way doesn't prevent you");
    AddExportText("    // from jetting without jumping");

    ExportBind("JumpAndJet(1);", "//bind(keyboard0, make, alt, \"whatever\", TO, \"JumpAndJet(1);\");");
    ExportBind("JumpAndJet(0);", "//bind(keyboard0, break, alt, \"whatever\", TO, \"JumpAndJet(0);\");");
}

WriterPrefs::save("jump_and_jet");

function jump_and_jet::init()
{
    needs("writer\\jump_and_jet.cs", "writer\\event.cs 2.7",
                                     "writer\\jet.cs 1.4",
                                     "writer\\save.cs 2.3",
                                     "writer\\you_respawned.cs 1.2");

    if($JumpAndJet::AlwaysOn)
        Event::Attach(eventJetsStarted, "JumpAndJet::onJetsStarted();");

    Event::Attach(eventYouRespawned, "JumpAndJet::onYouRespawned();");
}
Event::Attach(writerInit, "jump_and_jet::init();");

if(!$UsingWriterLoader) jump_and_jet::init();
